#!/usr/bin/python

#
# Generate 15 check bits for a Version 2 QR code
#
# Based on: http://www.thonky.com/qr-code-tutorial/format-version-information
#

data = 0b01010   # ECC error level (2 bits) | mode (3 bits)
                 # ECC: L = 01, M = 00, Q = 11, H = 10
                 # Modes: see http://www.thonky.com/qr-code-tutorial/mask-patterns
  
generator = 0b10100110111
XOR_res = 0b101010000010010 # QR spec says to XOR with these bits (mask)

#format string
fs = data << 10

counter = 1
while len("{0:b}".format(fs)) >= 11:
  print "Division number:", counter
  
  # Pad geneerator so it is same size as fs
  pad_gen = generator << len("{0:b}".format(fs)) - len("{0:b}".format(generator))

  # pad_gen ^ fs
  res = pad_gen ^ fs

  print "FS:", "{0:b}".format(fs), "Length:", len("{0:b}".format(fs))
  print "Pad Gen", "{0:b}".format(pad_gen), "Length:", len("{0:b}".format(pad_gen))
  print "Res", "{0:b}".format(res), "Length:", len("{0:b}".format(res))

  # Update fs
  fs = res
  
  print "\n",
  counter += 1
  
#Fs now contains result
combined = (data << len("{0:b}".format(fs))) + fs
print "combined:", "{0:b}".format(combined), "Length:", len("{0:b}".format(combined))

# Print final fs, padding 0's as needed to present 15 check bits
final_fs = combined ^ XOR_res
print "Final Format String:", "{:015b}".format(final_fs), "Length:", len("{:015b}".format(final_fs))
